<template>
  <TwoSidedPage>
    <template #title>
      Connexion
    </template>
    <template #content>
      <div class="row">
        <div class="col-xs-8 col-xs-offset-2">
          <form
            id="loginForm"
            novalidate="novalidate"
          >
            <div class="form-group">
              <label for="email">Email&nbsp;:</label>
              <input
                id="email"
                v-model="email"
                name="email"
                type="email"
                class="form-control"
                required="required"
              >
            </div>
            <div class="form-group">
              <label for="password">Mot de passe&nbsp;:</label>
              <div class="input-group">
                <input
                  id="password"
                  v-model="password"
                  name="password"
                  :type="passwordVisibility"
                  class="form-control"
                  autocomplete="off"
                  required="required"
                >
                <span class="input-group-btn">
                  <button
                    class="btn btn-default"
                    type="button"
                    @mousedown="showPassword"
                    @mouseup="hidePassword"
                  ><span class="fa fa-eye" /></button>
                </span>
              </div>
            </div>
            <div class="form-group btn-list">
              <click-button
                :disabled="isLoading || email.length === 0 || password.length === 0"
                @click="performLogin()"
              >
                <template slot="content">
                  Connexion
                </template>
              </click-button>
            </div>
          </form>
        </div>
      </div>
      <div class="row text-center">
        <p>
          Pas encore de compte ?
          <router-link :to="{ path: '/inscription'}">
            <a href="#">M'inscrire</a>
          </router-link>
        </p>
        <p>
          Mot de passe oublié ?
          <router-link :to="{ path: '/mot-de-passe-oublie'}">
            <a href="#">Récupérer</a>
          </router-link>
        </p>
      </div>
    </template>
  </TwoSidedPage>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import TwoSidedPage from '../components/Page/TwoSidedPage.vue'
import VanillaToasts from 'vanillatoasts'
import ClickButton from "../components/Button/ClickButton";

export default {
  name: 'Login',
  components: {ClickButton, TwoSidedPage},
  data() {
    return {
      passwordHidden: true,
      email: this.$route.params.email || '',
      password: '',
      validator: null,
    };
  },
  computed: {
    ...mapGetters([
      'logged',
      'csrfToken',
      'isLoading',
      'isAdmin',
      'isManager',
      'user',
      'wizard',
      'isOn',
      'isFirstSirenAdded',
      'isFirstDsnFileAddedAndStatusOk',
    ]),
    passwordVisibility() {
      return (this.passwordHidden) ? 'password' : 'text'
    }
  },
  mounted() {
    this.validator = $('#loginForm').submit(function(e) {
      e.preventDefault();
    }).validate({
      rules: {
        email: {
          required: true,
          email: true
        },
        password: {
          required: true,
        }
      },
      errorElement: "em",
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass("help-block");
        if(element[0]['name']=== "password" || element[0]['name']=== "passwordConfirm") {
          error.insertAfter(element[0]['parentElement'])
        }else if (element.prop("type") === "checkbox") {
          error.insertAfter(element.parent("label"));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  created() {
    this.onRefresh().then(()=>{
      if (this.logged) {
        this.redirectAfterLogin(this.$route.query.redirect);
      }
    })
  },
  methods: {
    ...mapActions([
      'onRefresh',
      'login',
      'loadingStarts',
      'loadingEnds',
      'setToken',
      'connect',
      'redirectAfterLogin'
    ]),
    // githubConnect() {
    //   this.connect('github').then((url) => {
    //     window.location.href = url
    //   })
    // },
    // googleConnect() {
    //   this.connect('google').then((url) => {
    //     window.location.href = url
    //   })
    // },
    performLogin() {
      this.validator.resetForm();
      if($("#loginForm").valid()) {
        this.loadingStarts()
        this.login({email: this.$data.email, password: this.$data.password})
          .then((data) => {
            this.setToken(data.token)
            VanillaToasts.create({
              title: 'Connexion',
              text: 'Opération réussie',
              type: 'success',
              timeout: 5000, // hide after 5000ms, // optional paremter
            });
            this.redirectAfterLogin(this.$route.query.redirect)
            this.loadingEnds()
          })
      }
    },
    hidePassword() {
      this.passwordHidden = true
    },
    showPassword() {
      this.passwordHidden = false
    }
  }
}
</script>
<style scoped>
.input-group .input-group-btn {
  z-index: 0 !important;
}
.input-group .form-control {
  z-index: 0 !important;
}
</style>